>From fd78b7a37d506e98e63111999e3a0dca5ec5ee83 Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Mon, 18 Mar 2013 11:29:52 -0400
Subject: [PATCH] Refactor installation code to remove dependency on jython

Connection is now made to the installation servlet through a python
client using JSON.  The code to construct the ConfgurationRequest and
parse the results has been moved to pkihelper.py, and configuration.py
no longer calls a separate jython process to create the Configuration
object and parse the results.  The jython code has therefore been removed.

Trac Ticket 532
---
 .../cms/servlet/test/ConfigurationTest.java        |  17 +-
 base/common/python/pki/client.py                   |  11 +-
 base/common/python/pki/encoder.py                  |  32 +
 base/common/python/pki/system.py                   |  32 +
 .../certsrv/system/ConfigurationRequest.java       |  11 +-
 .../certsrv/system/ConfigurationResponse.java      |   8 +-
 .../cms/servlet/csadmin/SystemCertDataFactory.java |   5 +-
 base/deploy/CMakeLists.txt                         |   2 -
 base/deploy/etc/default.cfg                        |   2 +-
 base/deploy/src/scriptlets/configuration.jy        | 111 ----
 base/deploy/src/scriptlets/configuration.py        |  36 +-
 base/deploy/src/scriptlets/finalization.py         |   2 +-
 base/deploy/src/scriptlets/instance_layout.py      |   2 +-
 base/deploy/src/scriptlets/pkiconfig.py            |  10 -
 base/deploy/src/scriptlets/pkihelper.py            | 681 ++++++++++++++++++---
 base/deploy/src/scriptlets/pkijython.py            | 667 --------------------
 base/deploy/src/scriptlets/pkimessages.py          |  67 +-
 base/deploy/src/scriptlets/pkiparser.py            |  24 +-
 base/deploy/src/scriptlets/security_databases.py   |   4 +-
 base/deploy/src/scriptlets/selinux_setup.py        |   4 +-
 specs/pki-core.spec                                |   6 +-
 21 files changed, 775 insertions(+), 959 deletions(-)
 create mode 100644 base/common/python/pki/encoder.py
 delete mode 100644 base/deploy/src/scriptlets/configuration.jy
 delete mode 100644 base/deploy/src/scriptlets/pkijython.py

diff --git a/base/common/functional/src/com/netscape/cms/servlet/test/ConfigurationTest.java b/base/common/functional/src/com/netscape/cms/servlet/test/ConfigurationTest.java
index c230815133e006cb85af17885a586a377f4119ac..25840cb3fbbfee0aefeb1eb6491b572b4bbc22a2 100644
--- a/base/common/functional/src/com/netscape/cms/servlet/test/ConfigurationTest.java
+++ b/base/common/functional/src/com/netscape/cms/servlet/test/ConfigurationTest.java
@@ -27,6 +27,7 @@ import java.security.NoSuchAlgorithmException;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.Iterator;
+import java.util.List;
 
 import netscape.security.x509.X500Name;
 
@@ -279,7 +280,7 @@ public class ConfigurationTest {
         data.setAdminCertRequestType("crmf");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
         SystemCertData cert1 = new SystemCertData();
         cert1.setTag("signing");
         cert1.setKeyAlgorithm("SHA256withRSA");
@@ -383,7 +384,7 @@ public class ConfigurationTest {
         data.setIssuingCA("https://" + host + ":9224");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
         SystemCertData cert1 = new SystemCertData();
         cert1.setTag("signing");
         cert1.setKeyAlgorithm("SHA256withRSA");
@@ -485,7 +486,7 @@ public class ConfigurationTest {
         data.setIssuingCA("External CA");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
         SystemCertData cert1 = new SystemCertData();
         cert1.setTag("signing");
         cert1.setKeyAlgorithm("SHA256withRSA");
@@ -588,7 +589,7 @@ public class ConfigurationTest {
         data.setStepTwo("true");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
         SystemCertData cert1 = new SystemCertData();
         cert1.setTag("signing");
         cert1.setKeyAlgorithm("SHA256withRSA");
@@ -695,7 +696,7 @@ public class ConfigurationTest {
         data.setBackupKeys("false");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
         SystemCertData cert3 = new SystemCertData();
         cert3.setTag("sslserver");
         cert3.setKeyAlgorithm("SHA256withRSA");
@@ -754,7 +755,7 @@ public class ConfigurationTest {
         data.setIssuingCA("https://" + host + ":9224");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
         SystemCertData cert1 = new SystemCertData();
         cert1.setTag("transport");
         cert1.setKeyAlgorithm("SHA256withRSA");
@@ -857,7 +858,7 @@ public class ConfigurationTest {
         data.setIssuingCA("https://" + host + ":9224");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
         SystemCertData cert1 = new SystemCertData();
         cert1.setTag("signing");
         cert1.setKeyAlgorithm("SHA256withRSA");
@@ -949,7 +950,7 @@ public class ConfigurationTest {
         data.setIssuingCA("https://" + host + ":9224");
 
         // create system certs
-        Collection<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
+        List<SystemCertData> systemCerts = new ArrayList<SystemCertData>();
 
         SystemCertData cert3 = new SystemCertData();
         cert3.setTag("sslserver");
diff --git a/base/common/python/pki/client.py b/base/common/python/pki/client.py
index 7635fe8797b422f5fbc36b244435a06e74b2852b..43b78e1af2760b62e8567a6beb2230701bb61db9 100644
--- a/base/common/python/pki/client.py
+++ b/base/common/python/pki/client.py
@@ -50,4 +50,13 @@ class PKIConnection:
             self.serverURI + '/rest/' + path,
             verify=False)
         r.raise_for_status()
-        return r
\ No newline at end of file
+        return r
+
+    def post(self, path, payload, headers):
+        r = self.session.post(
+                self.serverURI + '/rest/' + path,
+                verify=False,
+                data=payload,
+                headers=headers)
+        r.raise_for_status()
+        return r
diff --git a/base/common/python/pki/encoder.py b/base/common/python/pki/encoder.py
new file mode 100644
index 0000000000000000000000000000000000000000..56e0b0222a7d291b38a98fd48f4317c5ffcee72e
--- /dev/null
+++ b/base/common/python/pki/encoder.py
@@ -0,0 +1,32 @@
+import json
+import pki.system
+
+TYPES = { 'ConfigurationRequest': pki.system.ConfigurationRequest,
+          'ConfigurationResponse': pki.system.ConfigurationResponse }
+NOTYPES = { 'SystemCertData': pki.system.SystemCertData }
+
+class CustomTypeEncoder(json.JSONEncoder):
+    """A custom JSONEncoder class that knows how to encode core custom
+    objects.
+
+    Custom objects are encoded as JSON object literals (ie, dicts) with
+    one key, 'TypeName' where 'TypeName' is the actual name of the
+    type to which the object belongs.  That single key maps to another
+    object literal which is just the __dict__ of the object encoded."""
+
+    def default(self, obj):
+        for k, v in TYPES.items():
+            if isinstance(obj, v):
+                return { k: obj.__dict__ }
+        for k, v in NOTYPES.items():
+            if isinstance(obj, v):
+                return obj.__dict__
+        return json.JSONEncoder.default(self, obj)
+
+
+def CustomTypeDecoder(dct):
+    if len(dct) == 1:
+        type_name, value = dct.items()[0]
+        if type_name in TYPES:
+            return TYPES[type_name].from_dict(value)
+    return dct
diff --git a/base/common/python/pki/system.py b/base/common/python/pki/system.py
index f49cc402e7f7084210be6ba7c6990e6e0b50a177..51e899f98cfe828fb627450710d6d441611708b4 100644
--- a/base/common/python/pki/system.py
+++ b/base/common/python/pki/system.py
@@ -37,3 +37,35 @@ class SecurityDomainClient:
         info.name = j['DomainInfo']['@id']
 
         return info
+
+class ConfigurationRequest:
+
+    def __init__(self):
+        self.token = "Internal Key Storage Token"
+        self.isClone = "false"
+        self.secureConn = "off"
+        self.importAdminCert = "false"
+        self.generateServerCert = "true"
+        pass
+
+class ConfigurationResponse:
+
+    def __init__(self):
+        pass
+
+class SystemCertData:
+
+    def __init__(self):
+        pass
+
+class SystemConfigClient:
+
+    def __init__(self, connection):
+        self.connection = connection
+
+    def configure(self, data):
+        headers = {'Content-type': 'application/json',
+                   'Accept': 'application/json'}
+        r = self.connection.post('installer/configure', data, headers)
+        info = r.json()['ConfigurationResponse']
+        return info
diff --git a/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java b/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java
index 217f84b903f7890b02fe547f3bb37ec5e9848d70..170e1c031f042f6ae483c53d2382672b2d151c28 100644
--- a/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java
+++ b/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java
@@ -17,13 +17,12 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.certsrv.system;
 
-import java.util.Collection;
+import java.util.List;
 
 import javax.ws.rs.core.MultivaluedMap;
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
-import javax.xml.bind.annotation.XmlElementRef;
 import javax.xml.bind.annotation.XmlRootElement;
 
 /**
@@ -158,8 +157,8 @@ public class ConfigurationRequest {
     @XmlElement
     protected String replicationSecurity;
 
-    @XmlElementRef
-    protected Collection<SystemCertData> systemCerts;
+    @XmlElement
+    protected List<SystemCertData> systemCerts;
 
     @XmlElement
     protected String issuingCA;
@@ -553,7 +552,7 @@ public class ConfigurationRequest {
      *
      * @return systemCerts
      */
-    public Collection<SystemCertData> getSystemCerts() {
+    public List<SystemCertData> getSystemCerts() {
         return systemCerts;
     }
 
@@ -561,7 +560,7 @@ public class ConfigurationRequest {
      *
      * @param systemCerts
      */
-    public void setSystemCerts(Collection<SystemCertData> systemCerts) {
+    public void setSystemCerts(List<SystemCertData> systemCerts) {
         this.systemCerts = systemCerts;
     }
 
diff --git a/base/common/src/com/netscape/certsrv/system/ConfigurationResponse.java b/base/common/src/com/netscape/certsrv/system/ConfigurationResponse.java
index 6d3275a518af9d6510667b612131a74bfce9e574..cdd9de205edbfaa1d8de8bcfbf8d8d1482743096 100644
--- a/base/common/src/com/netscape/certsrv/system/ConfigurationResponse.java
+++ b/base/common/src/com/netscape/certsrv/system/ConfigurationResponse.java
@@ -20,11 +20,11 @@ package com.netscape.certsrv.system;
 import java.security.cert.CertificateEncodingException;
 import java.util.ArrayList;
 import java.util.Collection;
+import java.util.List;
 
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
-import javax.xml.bind.annotation.XmlElementRef;
 import javax.xml.bind.annotation.XmlRootElement;
 
 import netscape.security.x509.X509CertImpl;
@@ -39,8 +39,8 @@ import com.netscape.certsrv.apps.CMS;
 @XmlAccessorType(XmlAccessType.FIELD)
 public class ConfigurationResponse {
 
-    @XmlElementRef
-    protected Collection<SystemCertData> systemCerts;
+    @XmlElement
+    protected List<SystemCertData> systemCerts;
 
     @XmlElement
     protected SystemCertData adminCert;
@@ -63,7 +63,7 @@ public class ConfigurationResponse {
     /**
      * @param systemCerts the systemCerts to set
      */
-    public void setSystemCerts(Collection<SystemCertData> systemCerts) {
+    public void setSystemCerts(List<SystemCertData> systemCerts) {
         this.systemCerts = systemCerts;
     }
 
diff --git a/base/common/src/com/netscape/cms/servlet/csadmin/SystemCertDataFactory.java b/base/common/src/com/netscape/cms/servlet/csadmin/SystemCertDataFactory.java
index bd23c8f16bf6662d0567b50b1e42a812709a786b..aaaf17163bc32f9555c3cf258b86f36e1666415e 100644
--- a/base/common/src/com/netscape/cms/servlet/csadmin/SystemCertDataFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/csadmin/SystemCertDataFactory.java
@@ -20,6 +20,7 @@ package com.netscape.cms.servlet.csadmin;
 
 import java.util.ArrayList;
 import java.util.Collection;
+import java.util.List;
 
 import com.netscape.certsrv.system.SystemCertData;
 
@@ -37,8 +38,8 @@ public class SystemCertDataFactory {
         return data;
     }
 
-    public static Collection<SystemCertData> create(Collection<Cert> certs) {
-        Collection<SystemCertData> result = new ArrayList<SystemCertData>();
+    public static List<SystemCertData> create(Collection<Cert> certs) {
+        List<SystemCertData> result = new ArrayList<SystemCertData>();
         for (Cert cert : certs) {
             result.add(create(cert));
         }
diff --git a/base/deploy/CMakeLists.txt b/base/deploy/CMakeLists.txt
index ff9d64545e650fd722273e4e7c5ab1355e9bf18b..8483482c29af44503a88850664b9886d74c4d90a 100644
--- a/base/deploy/CMakeLists.txt
+++ b/base/deploy/CMakeLists.txt
@@ -107,7 +107,6 @@ install(
 
 install(
     FILES
-        src/scriptlets/configuration.jy
         src/scriptlets/configuration.py
         src/scriptlets/finalization.py
         src/scriptlets/infrastructure_layout.py
@@ -115,7 +114,6 @@ install(
         src/scriptlets/instance_layout.py
         src/scriptlets/pkiconfig.py
         src/scriptlets/pkihelper.py
-        src/scriptlets/pkijython.py
         src/scriptlets/pkilogging.py
         src/scriptlets/pkimanifest.py
         src/scriptlets/pkimessages.py
diff --git a/base/deploy/etc/default.cfg b/base/deploy/etc/default.cfg
index 32e744762e7b66a34164d83fe874c7385448633d..e848363ab138653bb5fe627de8c3eb765dade264 100644
--- a/base/deploy/etc/default.cfg
+++ b/base/deploy/etc/default.cfg
@@ -67,7 +67,7 @@ destroy_scriplets=
 # pki_http_port=80
 
 pki_admin_cert_file=%(pki_client_dir)s/ca_admin.cert
-pki_admin_cert_request_type=crmf
+pki_admin_cert_request_type=pkcs10
 pki_admin_dualkey=False
 pki_admin_keysize=2048
 pki_admin_password=
diff --git a/base/deploy/src/scriptlets/configuration.py b/base/deploy/src/scriptlets/configuration.py
index 248a43cf75486ff08e49305af535c60a959ce217..05016d7878f34372ddccd0b7685ab146b88a9312 100644
--- a/base/deploy/src/scriptlets/configuration.py
+++ b/base/deploy/src/scriptlets/configuration.py
@@ -25,6 +25,9 @@ from pkiconfig import pki_master_dict as master
 import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
+import json
+import pki.system
+import pki.encoder
 
 
 # PKI Deployment Configuration Scriptlet
@@ -85,16 +88,37 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 config.prepare_for_an_external_java_debugger(
                     master['pki_target_tomcat_conf_instance_id'])
             tomcat_instance_subsystems =\
-                util.instance.tomcat_instance_subsystems()
+                len(util.instance.tomcat_instance_subsystems())
             if tomcat_instance_subsystems == 1:
                 util.systemd.start()
             elif tomcat_instance_subsystems > 1:
                 util.systemd.restart()
 
-        # Pass control to the Java servlet via Jython 2.2 'configuration.jy'
-        util.jython.invoke(
-            master['pki_jython_configuration_scriptlet'],
-            master['resteasy_lib'])
+        # Optionally wait for debugger to attach (e. g. - 'eclipse'):
+        if config.str2bool(master['pki_enable_java_debugger']):
+            config.wait_to_attach_an_external_java_debugger()
+
+        # Construct PKI Subsystem Configuration Data
+        data = None
+        if master['pki_instance_type'] == "Apache":
+            if master['pki_subsystem'] == "RA":
+                config.pki_log.info(log.PKI_CONFIG_NOT_YET_IMPLEMENTED_1,
+                    master['pki_subsystem'],
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                return rv
+        elif master['pki_subsystem'] == "TPS":
+                config.pki_log.info(log.PKI_CONFIG_NOT_YET_IMPLEMENTED_1,
+                    master['pki_subsystem'],
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                return rv
+        elif master['pki_instance_type'] == "Tomcat":
+            # CA, KRA, OCSP, or TKS
+            data = util.config_client.construct_pki_configuration_data()
+        
+        # Configure the substem
+        util.config_client.configure_pki_data(
+            json.dumps(data, cls=pki.encoder.CustomTypeEncoder))
+
         return self.rv
 
     def respawn(self):
@@ -111,7 +135,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 util.directory.delete(master['pki_client_dir'])
             util.symlink.delete(master['pki_systemd_service_link'])
         elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
-             util.instance.tomcat_instance_subsystems() == 1:
+             len(util.instance.tomcat_instance_subsystems()) == 1:
             if util.directory.exists(master['pki_client_dir']):
                 util.directory.delete(master['pki_client_dir'])
             util.symlink.delete(master['pki_systemd_service_link'])
diff --git a/base/deploy/src/scriptlets/finalization.py b/base/deploy/src/scriptlets/finalization.py
index 8fe643e15f6c251e5be2fc128d402a13b361ce06..6ddc98d0361f6c2a978dba50081ae5e0fabceb95 100644
--- a/base/deploy/src/scriptlets/finalization.py
+++ b/base/deploy/src/scriptlets/finalization.py
@@ -105,7 +105,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
            util.instance.apache_instance_subsystems() >= 1:
             util.systemd.start()
         elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
-           util.instance.tomcat_instance_subsystems() >= 1:
+           len(util.instance.tomcat_instance_subsystems()) >= 1:
             util.systemd.start()
         config.pki_log.info(log.PKIDESTROY_END_MESSAGE_2,
                             master['pki_subsystem'],
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
index 773305c139f4b62f73c17969e90ef097337a12b4..843227a84e981ac109890a8c3410ae4bec4b739e 100644
--- a/base/deploy/src/scriptlets/instance_layout.py
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -170,7 +170,7 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 util.directory.delete(
                     master['pki_instance_type_registry_path'])
         elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS and\
-             util.instance.tomcat_instance_subsystems() == 0:
+             len(util.instance.tomcat_instance_subsystems()) == 0:
             # remove Tomcat instance base
             util.directory.delete(master['pki_instance_path'])
             # remove Tomcat instance logs
diff --git a/base/deploy/src/scriptlets/pkiconfig.py b/base/deploy/src/scriptlets/pkiconfig.py
index 1a4c77cb1defed1b541f94c9d5d978d21caf54f8..ad6c2225116d6f95d85ceaa1b94e0a7a2cccd0fe 100644
--- a/base/deploy/src/scriptlets/pkiconfig.py
+++ b/base/deploy/src/scriptlets/pkiconfig.py
@@ -94,14 +94,6 @@ PKI_DEPLOYMENT_DEFAULT_TOMCAT_HTTPS_PORT = 8443
 PKI_DEPLOYMENT_DEFAULT_TOMCAT_SERVER_PORT = 8005
 PKI_DEPLOYMENT_DEFAULT_TOMCAT_AJP_PORT = 8009
 
-# PKI Deployment Jython 2.2 Constants
-PKI_JYTHON_CRITICAL_LOG_LEVEL = 1
-PKI_JYTHON_ERROR_LOG_LEVEL = 2
-PKI_JYTHON_WARNING_LOG_LEVEL = 3
-PKI_JYTHON_INFO_LOG_LEVEL = 4
-PKI_JYTHON_DEBUG_LOG_LEVEL = 5
-
-
 # PKI Deployment Global Variables
 pki_install_time = None
 pki_timestamp = None
@@ -173,7 +165,6 @@ def wait_to_attach_an_external_java_debugger():
 
 
 # PKI Deployment Logger Variables
-pki_jython_log_level = None
 pki_log = None
 pki_log_dir = None
 pki_log_name = None
@@ -184,7 +175,6 @@ pki_console_log_level = None
 # PKI Deployment Global Dictionaries
 pki_master_dict = {}
 pki_slots_dict = None
-pki_master_jython_dict = None
 
 # PKI Selinux Constants and parameters
 PKI_INSTANCE_SELINUX_CONTEXT = "pki_tomcat_var_lib_t"
